//-------------------------------------------------------------------
// title: ESP32 pocket e-ink case
// author: OK1HRA 
// license: Creative Commons BY-SA
// URL: http://remoteqth.com
// revision: 0.1
// format: OpenSCAD
//-------------------------------------------------------------------
// HowTo:
// After open change inputs parameters and press F5
// .STL export press F6 and menu /Design/Export as STL...
//-------------------------------------------------------------------


//%   translate([0.2, 0.2, 0]) import("esp32-eink-02-pcb.stl", convexity = 5);
//%   translate([25.2+2, 17.45, 7]) cube([35, 30, 4],center=true);

// BASE
color([0.3, 1.0, 0.3]) 
base(1.5, 9.0+1.5);

//TOP
rotate([0,180,0]) translate([-50,-43,-9.8])
color([1,1,1]) 
top(1.5, 9.5, 0.0, 0);

// SEPARATOR
translate([0,40,-7.5])
separator(0.4, 9.5-4, 0.2);


module separator(WALL, ZZ, MINUS){
    difference(){
        hull(){
            translate([MINUS,MINUS,ZZ]) cube([1,1,WALL]);
            translate([49.2, 2.2, ZZ]) {cylinder(h=WALL, r=2.2-MINUS, center=false, $fn=30);}
            translate([2, 34.2, ZZ]) {cylinder(h=WALL, r=2.2-MINUS, center=false, $fn=30);}
            translate([49.2, 34.2, ZZ]) {cylinder(h=WALL, r=2.2-MINUS, center=false, $fn=30);}

        }
        translate([24-17, 34, ZZ-0.2]) cube([5.5+3, 3, 1]);
        translate([24, 34, ZZ-0.2]) cube([5.5+5.5, 3, 1]);
        translate([24+17-3, 34, ZZ-0.2]) cube([5.5+3, 3, 1]);
        translate([23, 0, ZZ-0.2]) cube([5.0, 3, 1]);
        translate([0, 14, ZZ-0.2]) cube([3, 5.0, 1]);
        translate([48.4, 15, ZZ-0.2]) cube([3, 5.0, 1]);

        translate([15, 32, ZZ-0.2]) cube([24, 5, 1]);
    }
     // BATT
        translate([MINUS, MINUS+2, ZZ]) cube([2, 10, 3.5]);
        translate([MINUS, MINUS, ZZ]) cube([10, 2, 3.5]);


        translate([37+2, MINUS+2, ZZ]) cube([1.5, 30, 3.5]);
        translate([5, 30+2, ZZ]) cube([10,1.5, 3.5]);
        //clip2
//        translate([27,MINUS, 0]) clip2(ZZ, EXPAND, WALL, MINUS);
//        translate([MINUS, 15, 0]) rotate([0,0,-90]) clip2(ZZ, EXPAND, WALL, MINUS);
//        translate([51.4-MINUS, 19, 0]) rotate([0,0,90]) clip2(ZZ, EXPAND, WALL, MINUS);
//        translate([31, 36.4-MINUS, 0]) rotate([0,0,180]) clip2(ZZ, EXPAND, WALL, MINUS);
//        if(EXPAND > 0){
//            translate([35, 36.4-MINUS, ZZ]) rotate([45,0,0]) cube([3+2*MINUS, WALL+EXPAND+1, WALL+1]);
//        }
}

module top(WALL, ZZ, MINUS, EXPAND){
    difference(){
        union(){
            difference(){
                hull(){
                    translate([MINUS,MINUS,ZZ]) cube([1,1,WALL+1]);
                    translate([49.2, 2.2, ZZ]) {cylinder(h=WALL+1, r=2.2-MINUS, center=false, $fn=30);}
                    translate([2, 34.2, ZZ]) {cylinder(h=WALL+1, r=2.2-MINUS, center=false, $fn=30);}
                    translate([49.2, 34.2, ZZ]) {cylinder(h=WALL+1, r=2.2-MINUS, center=false, $fn=30);}
                }
                // neodym
                translate([5.5+5, 28, ZZ+2.1]) rotate([180,0,0]) cylinder(h=2.5, d=10.0, center=false, $fn=60);
                translate([45.5-5, 28, ZZ+2.1]) rotate([180,0,0]) cylinder(h=2.5, d=10.0, center=false, $fn=60);
                //RQ
               translate([25, 18, ZZ+WALL+0.3]) rotate([0,0,-20]) scale([1.5, 1.5, 1]) rq(2);
            }
                // butt
                translate([26.7-17, 36.4, WALL-1.5]) Ubutt(WALL-1, ZZ);
                translate([26.7, 36.4, WALL-1.5]) Ubutt(WALL-1, ZZ);
                translate([26.7+17, 36.4, WALL-1.5]) Ubutt(WALL-1, ZZ);
                //clip2
                translate([27,MINUS, 0]) clip2(ZZ, EXPAND, WALL, MINUS);
                translate([MINUS, 15, 0]) rotate([0,0,-90]) clip2(ZZ, EXPAND, WALL, MINUS);
                translate([51.4-MINUS, 19, 0]) rotate([0,0,90]) clip2(ZZ, EXPAND, WALL, MINUS);
                translate([33, 36.4-MINUS, 0]) rotate([0,0,180]) clip2(ZZ, EXPAND, WALL, MINUS);
                if(EXPAND > 0){
//                    translate([35, 36.4-MINUS, ZZ+1]) rotate([45,0,0]) cube([3+2*MINUS, WALL+EXPAND+1, WALL+1]);
                }
        }
        if(EXPAND == 0){
            translate([0,0, ZZ]) ukos(WALL+0.8, -0.3);
        }
    }
}

module ukos(WALL, RR){
    difference(){
            hull(){
                translate([2.2, 2.2,-0.1]) {cylinder(h=WALL+0.4, d=25, center=false, $fn=30);}
                translate([49.2, 2.2,-0.1]) {cylinder(h=WALL+0.4, d=25, center=false, $fn=30);}
                translate([2, 34.2,-0.1]) {cylinder(h=WALL+0.4, d=25, center=false, $fn=30);}
                translate([49.2, 34.2, -0.1]) {cylinder(h=WALL+0.4, d=25, center=false, $fn=30);}
            }
            hull(){
                translate([2.2, 2.2,-0.2]) {cylinder(h=WALL+0.2, d1=7.65, d2=4.0+RR, center=false, $fn=30);}
                translate([49.2, 2.2,-0.2]) {cylinder(h=WALL+0.2, d1=7.65, d2=4.0+RR, center=false, $fn=30);}
                translate([2, 34.2,-0.2]) {cylinder(h=WALL+0.2, d1=7.65, d2=4.0+RR, center=false, $fn=30);}
                translate([49.2, 34.2, -0.2]) {cylinder(h=WALL+0.2, d1=7.65, d2=4.0+RR, center=false, $fn=30);}
            }
    }
}

module clip2(ZZ, EXPAND, WALL, MINUS){
    difference(){
        union(){
            if(EXPAND > 0){
                translate([-1.5, 0, ZZ-4+1.0]) rotate([0,90,0]) {cylinder(h=3+EXPAND, r=1.0+0.1, center=true, $fn=30);}
            }else{
                translate([-1.5, 0, ZZ-4+1.0]) rotate([0,90,0]) {cylinder(h=3, r=1.0, center=true, $fn=30);}
            }
            hull(){
                translate([0,0,ZZ-3.9]) rotate([0,180,0]) cube([3,1.0,0.1]);
                translate([0,0,ZZ]) rotate([0,180,0]) cube([3,2.0,0.1]);
            }
            if(EXPAND > 0){
                translate([-3-MINUS,-WALL-MINUS-1,ZZ]) rotate([0,0,0]) cube([3+2*MINUS, WALL+EXPAND+1, WALL+2.5]);
        //        translate([-3-MINUS,-1,ZZ]) rotate([-45,0,0]) cube([3+2*MINUS, WALL+EXPAND+1, WALL+1]);
            }else{
                translate([-3,-WALL-MINUS,ZZ]) cube([3, WALL+EXPAND+1, WALL+1]);
            }
        }
        if(EXPAND==0){
            translate([-4,-1,ZZ-2.7]) rotate([-140,0,0]) cube([5, WALL+EXPAND+1, WALL+1]);
        }

    }
}

module base(WALL, ZZ){
    difference(){
        union(){
            hull(){
                translate([2.2, 2.2, 0]) {cylinder(h=ZZ+WALL, d=4.4+2*WALL, center=false, $fn=30);}
                translate([49.2, 2.2, 0]) {cylinder(h=ZZ+WALL, d=4.4+2*WALL, center=false, $fn=30);}
                translate([2, 34.2, 0]) {cylinder(h=ZZ+WALL, d=4.4+2*WALL, center=false, $fn=30);}
                translate([49.2, 34.2, 0]) {cylinder(h=ZZ+WALL, d=4.4+2*WALL, center=false, $fn=30);}

                translate([2.2, 2.2, -2]) {cylinder(h=2, d1=4.4+2*WALL-4, d2=4.4+2*WALL, center=false, $fn=30);}
                translate([49.2, 2.2, -2]) {cylinder(h=2, d1=4.4+2*WALL-4, d2=4.4+2*WALL, center=false, $fn=30);}
                translate([2, 34.2, -2]) {cylinder(h=2, d1=4.4+2*WALL-4, d2=4.4+2*WALL, center=false, $fn=30);}
                translate([49.2, 34.2, -2]) {cylinder(h=2, d1=4.4+2*WALL-4, d2=4.4+2*WALL, center=false, $fn=30);}

    //            translate([2.2, 2.2, ZZ]) {cylinder(h=2, d2=4.4+2*WALL-3, d1=4.4+2*WALL, center=false, $fn=30);}
    //            translate([49.2, 2.2, ZZ]) {cylinder(h=2, d2=4.4+2*WALL-3, d1=4.4+2*WALL, center=false, $fn=30);}
    //            translate([2, 34.2, ZZ]) {cylinder(h=2, d2=4.4+2*WALL-3, d1=4.4+2*WALL, center=false, $fn=30);}
    //            translate([49.2, 34.2, ZZ]) {cylinder(h=2, d2=4.4+2*WALL-3, d1=4.4+2*WALL, center=false, $fn=30);}

            }
        // butt
//        translate([26.7-17, 36.3, 4.5]) sphere(d=5, $fn=30);
//        translate([26.7, 36.3, 4.5]) sphere(d=5, $fn=30);
//        translate([26.7+17, 36.3, 4.5]) sphere(d=5, $fn=30);
        }
        hull(){
            cube([1,1,ZZ+10]);
            translate([49.2, 2.2, 0]) {cylinder(h=ZZ+10, d=4.4, center=false, $fn=30);}
            translate([2, 34.2, 0]) {cylinder(h=ZZ+10, d=4.4, center=false, $fn=30);}
            translate([49.2, 34.2, 0]) {cylinder(h=ZZ+10, d=4.4, center=false, $fn=30);}
        }
        // e-ink
        hull(){
            translate([6.9, 1.4, -1.1+1.5]) cube([36.1,32.1, 0.1]);
            translate([6.9-0.5, 1.4, -1.1]) cube([36.6+0.5,32.1, 0.1]);
            }
        // flat cable
        translate([0, 9.5, -1.1]) cube([7.5,15.5,1.5]);
        // window
//        #translate([25.2+2, 17.45, -3]) cube([30, 30 ,4],center=true);
        translate([25.2+2, 17.45, -2.1]) minkowski(){
          cube([30-4, 30-4 ,0.2],center=true);
          cylinder(h=1.0, r1=2, r2=1, $fn=30);
        }
        // led
//        translate([26.7, 34.9, -2.1]) {cylinder(h=2.2, d2=2.5, d1=1, center=false, $fn=30);}
        translate([47.7, 30.7, -2.0+0.2]) {cylinder(h=2.2, d2=4, d1=1.5, center=false, $fn=30);}
        // usb
        hull(){
            translate([0.1, 2.6, 2.8]) rotate([0,-90,0]) {cylinder(h=WALL+0.2, d2=3.0, d1=4.0, center=false, $fn=30);}
            translate([0.1, 2.6+5.2, 2.8]) rotate([0,-90,0]) {cylinder(h=WALL+0.2, d2=3.0, d1=4.0,center=false, $fn=30);}
        }
        // butt
        translate([26.7-17, 36.3, 0]) Ucut(1.7, 9.0);
        translate([26.7, 36.3, 0]) Ucut(1.7, 9.0);
        translate([26.7+17, 36.3, 0]) Ucut(1.7, 9.0);
        // clip from top
        top(1.5, 9.5, 0.2, 1);
        // mount point
        translate([2, 34.9, 3.5]) rotate([0,90,90]) cylinder(h=5, d=1.5, center=false, $fn=30);
        translate([2, 33.9, 3.5]) rotate([0,90,180]) cylinder(h=5, d=1.5, center=false, $fn=30);
       // ukos 
       translate([0,0, ZZ-0.9]) ukos(WALL+0.7, -0.2);
    }
    // butt support
    //    translate([26.7-1-17, 36.4-0.2, -0.5]) cube([2, 0.5, 3]);
    //    translate([26.7-1, 36.4-0.2, -0.5]) cube([2, 0.5, 3]);
    //    translate([26.7-1+17, 36.4-0.2, -0.5]) cube([2, 0.5, 3]);
    translate([-0.9, 27, 2.0]) rotate([0,45,0]) cube([1,5,1]);
    translate([50.8, 24, 2.0]) rotate([0,45,0]) cube([1,10,1]);

    // top supports
//    translate([-0.25,20,ZZ]) rotate([180,0,0]) clip(1,3);
//    translate([51.4+0.5,17,ZZ]) rotate([180,0,180]) clip(1,3);
//    translate([24,-0.5,ZZ]) rotate([180,0,90]) clip(1,3);
//    translate([27-4,36.4+0.5,ZZ]) rotate([180,0,-90]) clip(1,3);

}
    
module clip(xx, yy){
    difference(){
        translate([0,0,0]) rotate([0,0,0]) cube([xx,yy,yy], center=false);
        translate([xx,-0.1,0]) rotate([0,-17,0]) cube([xx+1,yy+0.2,yy+1], center=false);
    }
}

module Ubutt(yy, zz){
    difference(){
//        union(){
//            translate([0, 0, 2.5]) rotate([-90,0,0]) {cylinder(h=yy, d=5, center=false, $fn=30);}
//            translate([-5.0/2, 0, 2.5]) cube([5.0, yy,zz]);
//        }
    hull(){
        translate([0, -0.2, 2.5]) rotate([-90,0,0]) {cylinder(h=yy+1.2, d=4.5, center=false, $fn=30);}
        translate([-4.5/2, -0.3, 2.5]) cube([4.5,yy+1.3,zz]);
    }
//   }
//    translate([0, 1.3, 2.2]) rotate([-120,0,0]) {cylinder(h=yy, d=4.7, center=false, $fn=30);}
    hull(){
        translate([-2.5, -1.5, zz-2.3]) rotate([0,90,0]) {cylinder(h=5, d=5, center=false, $fn=30);}
        translate([-2.5, -1.5, zz-4.2]) rotate([0,90,0]) {cylinder(h=5, d=5, center=false, $fn=30);}
    }
}
difference(){
        translate([0, 0, 2.5]) sphere(d=5, $fn=30);
        translate([0, -5.2, 2.5]) rotate([-90,0,0]) {cylinder(h=yy+1.2+5, d=6.5, center=false, $fn=30);}
    }
}

module Ucut(yy, zz){
    difference(){
        union(){
            translate([0, 0, 2.5]) rotate([-90,0,0]) {cylinder(h=yy, d=5, center=false, $fn=30);}
            translate([-5.0/2, 0, 2.5]) cube([5.0, yy,zz+1]);
        }
//    translate([0, -1, 2.5]) rotate([-90,0,0]) {cylinder(h=7, d=4.5, center=false, $fn=30);}
//    translate([-4.5/2, -1, 2.5]) cube([4.5,7,zz-2.4]);
   }
//    translate([0, 1.3, 2.2]) rotate([-120,0,0]) {cylinder(h=yy, d=4.7, center=false, $fn=30);}
//    hull(){
//        translate([-2.5, -1.5, zz-2]) rotate([0,90,0]) {cylinder(h=5, d=5, center=false, $fn=30);}
//        translate([-2.5, -1.5, zz-4]) rotate([0,90,0]) {cylinder(h=5, d=5, center=false, $fn=30);}
//    }
}


fudge = 0.1;
module rq(h)
{
  scale([25.4/90, -25.4/90, 1]) union()
  {
    linear_extrude(height=h)
      polygon([[-7.281275,-22.968725],[-9.218775,-22.687475],[-11.086650,-21.758780],[-12.571819,-20.311942],[-13.552341,-18.466933],[-13.906275,-16.343725],[-13.875075,8.125025],[-11.843825,3.968775],[-11.562525,3.562525],[-11.562525,-16.343725],[-11.369259,-17.631210],[-10.828399,-18.759736],[-9.998352,-19.672444],[-8.937525,-20.312475],[-7.281275,-20.656225],[12.093725,-20.625025],[13.773681,-20.293083],[15.133026,-19.383076],[16.043033,-18.023731],[16.374975,-16.343775],[16.406175,16.343725],[16.074232,18.023677],[15.164223,19.383023],[13.804877,20.293032],[12.124925,20.624975],[1.062425,20.624975],[-0.093825,21.218725],[-0.156325,21.624975],[-0.425195,22.379917],[-0.968825,22.968725],[12.093675,22.937525],[14.667363,22.420090],[16.773759,21.008226],[18.196363,18.912575],[18.718675,16.343775],[18.718675,-16.343725],[18.201243,-18.917406],[16.789376,-21.023805],[14.693722,-22.446414],[12.124925,-22.968725],[-7.281325,-22.968725]]);
    linear_extrude(height=h)
      polygon([[10.968725,-16.437475],[-6.156275,-16.406275],[-6.875025,-16.281275],[-7.685400,-15.619512],[-8.000025,-14.593775],[-8.000025,3.062475],[-7.562525,3.156175],[-6.750756,3.499552],[-6.165395,4.158513],[-5.920108,5.005101],[-6.062525,5.874925],[-6.656275,7.374925],[-5.656275,7.593675],[-4.837019,7.995139],[-4.281275,8.718675],[-3.656275,8.843675],[-2.531275,9.062425],[-1.699656,9.444093],[-1.125025,10.156175],[-1.031325,10.187375],[-0.937625,10.218575],[-0.343875,10.343575],[0.486230,10.772203],[1.031125,11.531075],[1.437375,11.749825],[10.968725,11.781025],[12.272699,11.225624],[12.812475,9.906025],[12.812475,-14.593975],[12.272699,-15.897949],[10.968725,-16.437725]]);
    linear_extrude(height=h)
      polygon([[-9.906275,4.781275],[-9.906275,4.812475],[-9.999975,4.874975],[-10.031175,4.843775],[-12.249925,9.375025],[-14.468675,14.000025],[-15.062425,13.812525],[-15.656175,13.687525],[-15.093675,12.656275],[-14.562425,11.625025],[-15.218675,11.468775],[-15.843675,11.312525],[-15.656175,10.968775],[-15.437425,10.625025],[-16.656175,10.375025],[-17.843675,10.062525],[-18.281175,10.750025],[-18.718675,11.406275],[-18.093675,11.562525],[-17.468675,11.718775],[-17.687425,12.062525],[-17.874925,12.375025],[-17.249925,12.531275],[-16.624925,12.687525],[-16.999925,13.375025],[-17.374925,14.093775],[-16.749925,14.250025],[-16.093675,14.437525],[-16.437425,15.093775],[-16.812425,15.781275],[-16.156175,15.968775],[-15.468675,16.125025],[-15.812425,16.875025],[-16.156175,17.593775],[-15.468675,17.781275],[-14.781175,17.968775],[-15.093675,18.718775],[-15.374925,19.437525],[-9.593675,21.031275],[-3.749925,22.593775],[-3.624925,21.781275],[-3.437425,20.968775],[-2.781175,21.156275],[-2.124925,21.312525],[-1.937425,20.093775],[-1.749925,18.906275],[-1.062425,19.062525],[-0.343675,19.218775],[-0.031175,16.312525],[0.281325,13.375025],[-0.312425,13.250025],[-0.906175,13.093775],[-0.843675,12.687525],[-0.781175,12.312525],[-1.374925,12.156275],[-1.968675,12.062575],[-2.156175,13.281325],[-2.343675,14.500075],[-2.968675,14.343825],[-3.593675,14.218825],[-3.281175,12.593825],[-2.937425,11.031325],[-4.062425,10.781325],[-5.218675,10.531325],[-5.531175,11.687575],[-5.812425,12.843825],[-6.406175,12.687575],[-6.999925,12.562575],[-6.562425,11.062575],[-6.093775,9.531325],[-7.187525,9.281325],[-8.312525,9.062575],[-8.875025,10.531325],[-9.406275,12.031325],[-10.000025,11.875075],[-10.625025,11.750075],[-9.281275,8.437575],[-7.937525,5.125075],[-8.906275,4.937575],[-9.906275,4.781325]]);
    linear_extrude(height=h)
      polygon([[2.124975,14.625025],[1.937475,16.500025],[1.812475,17.812525],[3.218725,17.781325],[3.929543,17.492142],[4.218725,16.781325],[4.218725,15.656325],[3.913914,14.929882],[3.187475,14.625075],[2.124975,14.625075]]);
    linear_extrude(height=h)
      polygon([[9.531225,14.625025],[9.124975,14.718725],[8.675304,15.071853],[8.499975,15.624975],[8.531175,16.781225],[8.820361,17.492043],[9.531175,17.781225],[11.124925,17.812425],[11.835746,17.507614],[12.124925,16.781175],[12.124925,15.624925],[11.835743,14.914111],[11.124925,14.624925],[9.531175,14.624925]]);
  }
}
